'' =================================================================================================
''
''   File....... RiverLights1.spin
''   Purpose.... 
''   Author..... BillyS (aka Lockadoc)
''               Copyright (c) 2009 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... Lockadoc@Aol.Com
''   Started.... 10 Oct 2009
''   Updated....        2009
''
'' =================================================================================================
{{                     Light output Led's are on pins 0-7
                       HeartBeat Led in on pin 15
                       IR Receiver in on pin 16
                       Photoresistor in on pin 8     }}

{{ The goal I'm going for in this object is an Eight channel light timer for some party lights.
         I have a four hundred foot long chain of 120 volt lights. the controller will be in the middle with
         four channels to the left and four to the right using 8)25amp solid state relays.All the lights will
         come on at dusk,than at 11:00pm 2 channels will go off, at 12:00am 2 more cannels will go off, than at 1:00am
         2 more channel will go off. Leaving the two remaing channels on until dawn.

          Added features:

           1- Have some preprogrammed light displays  (something like the Experiment #7:"A Lighting Controller"
              from the book basic stamp book StampWorks and the "Mother of all LED sequencers" from the Propeller
              object exchange) that run for a few minutes than return to the default light timing control

           2- A tv remote control to change the light display 

           3- With the push of a button (one on the contoller box with an other on the Tv remote control)
              all lights will go back on for one hour then return to the default timing control  

           4- a heartbeat led blinking to let me know its running }} 



                       
con

  _clkmode = xtal1 + pll16x                                     'Clock Speed
  _xinfreq = 5_000_000                                          'Cystal Speed
  _8ChannelsOn = %11111111                                      'All 8 Channels On                                                                                                                                             
  _6ChannelsOn = %01110111                                      'Only 6 Channels On
  _4ChannelsOn = %00110011                                      'Only 4 Channels On
  _2ChannelsOn = %00010001                                      'Only 2 Channels On
  _0ChannelsOn = %00000000                                      'No channels On


  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control  
Var
  Byte pattern                                                   ' all  channels of leds 
  long Day
  long Hour
  long Minute
  long Second
  long TotalMinutesOfDay
  
  
Obj

  term : "fullduplexserialPlus"                                 ' tx serial
  rtc  : "jm_softrtc"                                           ' real time clock
  Display3 :"Display3"                                          ' Another Led Display
  Display4 :"Display4"                                          ' Another Led Display 
  Display5 :"Display5"                                          ' Another Led Display 
  Display6 :"Display6"                                          ' Another Led Display 
  Display7 :"Display7"                                          ' Another Led Display 
  HeartBeat :"Lifewithcog"
Pub Main

  term.start(31, 30, %0000, 115_200)                            ' start termial
  waitcnt(clkfreq / 100 + cnt)
  term.tx(CLS)

  rtc.init
  rtc.initx(49, 58, 22, 1)                                      'Sets clock start time of 10:58:49 Monday
     'if you want to set the rtc to a certain time IE. 15:37:49 tuesday you would use
     'time.initx(49, 37, 15, 2) 

 'heartbeat .start                                              'starts heatbeat Led in new cog
  repeat
    waitcnt(clkfreq / 3 + cnt)                                  'places the clock into the Serial Terminal Display 
    term.tx(HOME)
    print2(rtc.gethrs)
    term.tx(":")
    print2(rtc.getmins)
    term.tx(":")
    print2(rtc.getsecs) 
    term.tx(" ")


    case rtc.getday
      0 : term.str(string("SUN"))
      1 : term.str(string("MON")) 
      2 : term.str(string("TUE"))
      3 : term.str(string("WED"))
      4 : term.str(string("THU")) 
      5 : term.str(string("FRI"))
      6 : term.str(string("SAT"))

    term.tx(CR)
    print2(rtc.todmins / 100)
    print2(rtc.todmins // 100)
      
  
    'shortcut to Speed Up Clock FOR TESTING
    if rtc.getsecs == 10                 'if seconds == 10
      Minute := rtc.getmins              'keep minute
      hour := rtc.gethrs
      rtc.set(58, Minute, hour, 0)          'but force seconds to 58 seconds


   if hour => 17
         pattern := _8channelsOn               ' All channels come on at 5:00 pm
     
        if hour == 23                          ' first two channels going out at 11:00 pm
         pattern := _6ChannelsOn

        if hour == 24                          ' second set of channels going out at 12:00am
         pattern := _4ChannelsOn

        if hour == 1                           ' Third set of channels going out at 1:00 am
          pattern :=_2ChannelsOn

        if hour == 5
         pattern := _0ChannelsOn               ' Last set of lights going out at 5:00 am
          
  





  
pub print2(val)

  if val < 10
    term.tx("0")

  term.dec(val)




 